Bug 445025 - gnome-sessions-save doesn't work from screensaver
gnome-sessions-save doesn't work from screensaver
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gnome-session (Show other bugs)
9
All Linux
low Severity medium
: ---
: ---
Assigned To: Ray Strode [halfline]
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-05-02 15:18 EDT by Josh Lange
Modified: 2009-07-14 12:18 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 12:18:20 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Josh Lange 2008-05-02 15:18:09 EDT
Description of problem:
acording to: http://live.gnome.org/GnomeScreensaver/FrequentlyAskedQuestions

I should be able to use "gnome-session-save --silent --kill" to kill the gnome
workspace for the current user, in the context of gnome-screensaver. I set this
as a mandatory and per user key in the gconf. I used strace to confirm that the
program is being executed, it is.

Actual results:
Nothing happens

Expected results:
The user gets logged out

Version-Release number of selected component (if applicable):
fedora 9 preview

How reproducible:
Always

Details:
$ strace -f -p `/sbin/pidof gnome-screensaver` -e trace=execve,fork
Process 22320 attached - interrupt to quit
Process 22481 attached (waiting for parent)
Process 22481 resumed (parent 22320 ready)
[pid 22481] execve("/usr/libexec/gnome-screensaver-gl-helper",
["/usr/libexec/gnome-screensaver-g"...], [/* 22 vars */]) = 0
Process 22481 detached
--- SIGCHLD (Child exited) @ 0 (0) ---
Process 22483 attached
[pid 22483] execve("/usr/libexec/gnome-screensaver-dialog",
["/usr/libexec/gnome-screensaver-d"..., "--enable-logout"...,
"--logout-command=gnome-session-s"..., "--away-message="...], [/* 22 vars */]) = 0
Process 22484 attached
Process 22485 attached
[pid 22485] execve("/sbin/unix_chkpwd", ["/sbin/unix_chkpwd"..., "langejh"...,
"nullok"...], [/* 0 vars */]) = 0
Process 22485 detached
Process 22487 attached
Process 22488 attached
[pid 22488] execve("/usr/local/bin/gnome-session-save",
["gnome-session-save"..., "--kill"..., "--silent"...], [/* 22 vars */]) = -1
ENOENT (No such file or directory)
[pid 22488] execve("/usr/bin/gnome-session-save", ["gnome-session-save"...,
"--kill"..., "--silent"...], [/* 22 vars */]) = 0
Process 22483 suspended
Process 22483 resumed
Process 22487 detached
[pid 22483] --- SIGCHLD (Child exited) @ 0 (0) ---
Process 22488 detached
Process 22489 attached
Process 22490 attached
[pid 22490] execve("/usr/local/bin/gnome-session-save",
["gnome-session-save"..., "--kill"..., "--silent"...], [/* 22 vars */]) = -1
ENOENT (No such file or directory)
[pid 22490] execve("/usr/bin/gnome-session-save", ["gnome-session-save"...,
"--kill"..., "--silent"...], [/* 22 vars */]) = 0
Process 22489 detached
[pid 22483] --- SIGCHLD (Child exited) @ 0 (0) ---
Process 22490 detached
Process 22491 attached
Process 22492 attached
[pid 22492] execve("/usr/local/bin/gnome-session-save",
["gnome-session-save"..., "--kill"..., "--silent"...], [/* 22 vars */]) = -1
ENOENT (No such file or directory)
[pid 22492] execve("/usr/bin/gnome-session-save", ["gnome-session-save"...,
"--kill"..., "--silent"...], [/* 22 vars */]) = 0
Process 22491 detached
[pid 22483] --- SIGCHLD (Child exited) @ 0 (0) ---
Process 22492 detached
Process 22493 attached (waiting for parent)
Process 22493 resumed (parent 22483 ready)
Process 22494 attached (waiting for parent)
Process 22494 resumed (parent 22493 ready)
[pid 22494] execve("/usr/local/bin/gnome-session-save",
["gnome-session-save"..., "--kill"..., "--silent"...], [/* 22 vars */]) = -1
ENOENT (No such file or directory)
[pid 22494] execve("/usr/bin/gnome-session-save", ["gnome-session-save"...,
"--kill"..., "--silent"...], [/* 22 vars */]) = 0
Process 22483 suspended
Process 22483 resumed
Process 22493 detached
[pid 22483] --- SIGCHLD (Child exited) @ 0 (0) ---
Process 22494 detached
Process 22495 attached (waiting for parent)
Process 22495 resumed (parent 22483 ready)
Process 22496 attached (waiting for parent)
Process 22496 resumed (parent 22495 ready)
[pid 22496] execve("/usr/local/bin/gnome-session-save",
["gnome-session-save"..., "--kill"..., "--silent"...], [/* 22 vars */]) = -1
ENOENT (No such file or directory)
[pid 22496] execve("/usr/bin/gnome-session-save", ["gnome-session-save"...,
"--kill"..., "--silent"...], [/* 22 vars */]) = 0
Process 22483 suspended
Process 22483 resumed
Process 22495 detached
[pid 22483] --- SIGCHLD (Child exited) @ 0 (0) ---
Process 22496 detached
Process 22320 detached
Process 22483 detached
Process 22484 detached
Comment 1 jmccann 2008-05-07 13:55:54 EDT
So, the problem is that gnome-screensaver is launched by gnome-settings-daemon
and gnome-settings-daemon is D-Bus activated.  The D-Bus session bus is started
before gnome-session and therefore doesn't know the SESSION_MANAGER environment
variable.  This causes gnome-session-save to fail.
Comment 2 Matthias Clasen 2008-05-07 20:03:23 EDT
This is a problem that we've seen in a number of places. 
Is there some reason that dbus should have to clean the environment when
activating stuff on the session bus ? this is not system bus activation...
Comment 3 jmccann 2008-05-07 20:25:56 EDT
Well, it is just that the session bus doesn't know anything about the
SESSION_MANAGER or gnome-session.

Dan says that for 2.24 there will be a D-Bus API for logout.  So, we can port
gnome-session-save to use it.  If we want to fix this before then the options
aren't quite as nice.  Probably making gnome-settings-daemon not be activated is
the simplest...
Comment 4 Bug Zapper 2008-05-14 06:33:02 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2009-06-09 20:34:47 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2009-07-14 12:18:20 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.